function getenv(name)
{
  var environment =
  Components.classes["@mozilla.org/process/environment;1"]
            .getService(Components.interfaces.nsIEnvironment);
  return environment.get(name);
}

function FindExecutable(name)
{
  var path = getenv("PATH");
  var sep = ":", psep = "/";
  if (navigator.platform.substring(0, 5) == "Win32")
  {
    sep = ";";
    psep = "\\";
    name = name + ".exe"
  }
  var idx;
  while ((idx = path.indexOf(sep)) != -1)
  {
    try
    {
      var subpath = path.substring(0, idx);
      path = path.substring(idx + 1);
      var fullpath = subpath + psep + name;
      var lf = Components.classes["@mozilla.org/file/local;1"]
                         .createInstance(Components.interfaces.nsILocalFile);
      lf.initWithPath(fullpath);
      if (lf.exists())
        return fullpath;
    }
    catch (e)
    {
    }
  }
  return null;
}

function GetCompiler()
{
  var prefservice =
  Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefService);
  var cellBranch = prefservice.getBranch("physiome.mozcellml.");
  var compline, cc;
  try
  {
    compline = cellBranch.getCharPref("compiler");
  }
  catch (e)
  {
    cc = FindExecutable("gcc");
    if (cc == null)
    {
      cc = "/usr/bin/gcc";
    }

    var gecko_sdk = "/usr/local/gecko-sdk/";
    if (navigator.platform.substring(0, 5) == "Win32")
    {
      gecko_sdk = "c:\\gecko-sdk\\";
    }
    var libPath = "-L" + gecko_sdk + "bin";
    var includePath = "-I" + gecko_sdk + "include" + " -I";
    var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
                               .getService(Components
                                           .interfaces
                                           .nsIDirectoryServiceProvider);
    var p = new Object();
    var components = dirService.getFile("ComsD", p);
    includePath += components.path;

    var compline = cc + " -O3 " + libPath + " " + includePath + " -lnspr4 -lm";
    if (navigator.platform.substring(0, 5) == "Win32" && 0)
    {
      // Change single slashes to double slashes...
      var tc = compline;
      var i = 0;
      var l = tc.length;
      for (; i < l; i++)
      {
        var c = tc.substring(i, i + 1);
        if (c == "\\")
          compline += "\\\\";
        else
          compline += c;
      }
    }
    cellBranch.setCharPref("compiler", compline);
  }
  return compline;
}

function LoadModel(filename)
{
  this.model = Components.classes["@physiome.org/mozCellML;1"]
                  .createInstance(Components.interfaces.mozICellML);
  this.error = model.readDocument(filename);
  return this;
}

function QueryVariable(sup)
{
    return sup.QueryInterface(Components.interfaces.mozCellMLIVariable);
}

function ModelLoadObserver()
{
}

ModelLoadObserver.prototype =
{
  QueryInterface: function (aIID)
  {
    if (
        aIID.equals(Components.interfaces.nsIStreamLoaderObserver) ||
        aIID.equals(Components.interfaces.nsISupports)
       )
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  onStreamComplete: function (loader, ctxt, status, resultLength, result)
  {
    this.statusBar.label = "Document Loaded";
  }
};

function UserRequestLoad(location)
{
  var statusBar = document.getElementById('status-bar-display');
  statusBar.label = "Loading " + location + "...";
  location = "mozcellml:" + location;

  var url = Components.classes["@mozilla.org/network/standard-url;1"]
                      .createInstance(Components.interfaces.nsIURI);
  var chan = Components.classes["@mozilla.org/network/io-service;1"]
                       .getService(Components.interfaces.nsIIOService)
                       .newChannel(location, null, null);
  url.spec = location;
  chan.originalURI = url;

  window.loader = Components.classes["@mozilla.org/network/stream-loader;1"]
                            .createInstance(Components.interfaces.nsIStreamLoader);
  var mlo = new ModelLoadObserver();
  mlo.statusBar = statusBar;
  window.loader.init(chan, mlo, null);
}

function SelectLocalModel(returnto)
{
  var chosen = {
             buttonStatus: 0,
             files: null,
             filterIndex: 0
           };
  var pickObject =
  {
    retvals: chosen,
    title: "Choose a model to load",
    mode: Components.interfaces.nsIFilePicker.modeOpen,
    displayDirectory: null,
    defaultString: "model.cml",
    filters:
    {
      titles: ["All CellML", "CML", "XML", "All Files"],
      types: ["*.cml; *.xml", "*.cml", "*.xml", "*"]
    },
    filterIndex: 0
  };
  window.openDialog(
                    "chrome://global/content/filepicker.xul",
                    "_blank",
                    "chrome,modal",
                    pickObject
                   );
  if (chosen.buttonStatus != Components.interfaces.nsIFilePicker.returnOK)
    return;
  var uri = Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService)
            .newFileURI(chosen.files.getNext());
  returnto.value = uri.spec;
}
